#!/bin/sh

#create Pool
mcsop mkmdiskgrp -ext 1024 -guiid 0 -intier auto -name Pool0 -warning 80%
mcsop mkmdiskgrp -ext 1024 -guiid 0 -intier auto -name Pool1 -warning 80%
mcsop mkmdiskgrp -ext 1024 -guiid 0 -intier auto -name Pool2 -warning 80%
mcsop mkmdiskgrp -ext 1024 -guiid 0 -intier auto -name Pool3 -warning 80%
mcsop mkmdiskgrp -ext 1024 -guiid 0 -intier auto -name Pool4 -warning 80%
mcsop mkmdiskgrp -ext 1024 -guiid 0 -intier auto -name Pool5 -warning 80%
mcsop mkmdiskgrp -ext 1024 -guiid 0 -intier auto -name Pool6 -warning 80%
mcsop mkmdiskgrp -ext 1024 -guiid 0 -intier auto -name Pool7 -warning 80%

#initial driver
for i in {0..399}
do 
  mcsop chdrive -use candidate $i
  usleep 100000
done

#create mdisk(raid) 
cur1=0
cur2=0
cur3=0
cur4=0
cur5=0
cur6=0
cur7=0
cur8=0
cur9=0
cur10=0
cur11=0
cur12=0
cur13=0
cur14=0
cur15=0
cur16=0

lsdrive|awk 'NR>1{print $1,$6}'|while read id enid
do
   [ $enid -eq 1 ] && en1=$en1"$id"":" && let cur1+=1 && [ $cur1 -eq 12 ] && mcsop mkarray -drive ${en1%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool0 && cur1=0 && en1=""
   [ $enid -eq 2 ] && en2=$en2"$id"":" && let cur2+=1 && [ $cur2 -eq 12 ] && mcsop mkarray -drive ${en2%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool0 && cur2=0 && en2=""
   [ $enid -eq 3 ] && en3=$en3"$id"":" && let cur3+=1 && [ $cur3 -eq 12 ] && mcsop mkarray -drive ${en3%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool1 && cur3=0 && en3=""
   [ $enid -eq 4 ] && en4=$en4"$id"":" && let cur4+=1 && [ $cur4 -eq 12 ] && mcsop mkarray -drive ${en4%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool1 && cur4=0 && en4=""
   [ $enid -eq 5 ] && en5=$en5"$id"":" && let cur5+=1 && [ $cur5 -eq 12 ] && mcsop mkarray -drive ${en5%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool2 && cur5=0 && en5=""
   [ $enid -eq 6 ] && en6=$en6"$id"":" && let cur6+=1 && [ $cur6 -eq 12 ] && mcsop mkarray -drive ${en6%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool2 && cur6=0 && en6=""
   [ $enid -eq 7 ] && en7=$en7"$id"":" && let cur7+=1 && [ $cur7 -eq 12 ] && mcsop mkarray -drive ${en7%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool3 && cur7=0 && en7=""
   [ $enid -eq 8 ] && en8=$en8"$id"":" && let cur8+=1 && [ $cur8 -eq 12 ] && mcsop mkarray -drive ${en8%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool3 && cur8=0 && en8=""
   [ $enid -eq 9 ] && en9=$en9"$id"":" && let cur9+=1 && [ $cur9 -eq 12 ] && mcsop mkarray -drive ${en9%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool4 && cur9=0 && en9=""
   [ $enid -eq 10] && en10=$en10"$id"":" && let cur10+=1 && [ $cur10 -eq 12 ] && mcsop mkarray -drive ${en10%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool4 && cur10=0 && en10=""
   [ $enid -eq 11] && en11=$en11"$id"":" && let cur11+=1 && [ $cur11 -eq 12 ] && mcsop mkarray -drive ${en11%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool5 && cur11=0 && en11=""
   [ $enid -eq 12] && en12=$en12"$id"":" && let cur12+=1 && [ $cur12 -eq 12 ] && mcsop mkarray -drive ${en12%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool5 && cur12=0 && en12=""
   [ $enid -eq 13] && en13=$en13"$id"":" && let cur13+=1 && [ $cur13 -eq 12 ] && mcsop mkarray -drive ${en13%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool6 && cur13=0 && en13=""
   [ $enid -eq 14] && en14=$en14"$id"":" && let cur14+=1 && [ $cur14 -eq 12 ] && mcsop mkarray -drive ${en14%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool6 && cur14=0 && en14=""
   [ $enid -eq 15] && en15=$en15"$id"":" && let cur15+=1 && [ $cur15 -eq 12 ] && mcsop mkarray -drive ${en15%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool7 && cur15=0 && en15=""
   [ $enid -eq 16] && en16=$en16"$id"":" && let cur16+=1 && [ $cur16 -eq 12 ] && mcsop mkarray -drive ${en16%?} -level raid10 -sparegoal 0 -strip 256 -createsync Pool7 && cur16=0 && en16=""  
done



#create vdisk(lun)
for j in {0..7}
do
  let m=2*j+1
  let n=2*j+2
  for i in {0..9}
  do
    echo "mcsop mkvdisk -accessiogrp $j -cache readwrite -iogrp $j -mdiskgrp $j -name node${m}_${i} -node $m -nofmtdisk -size 1825361100800 -unit b"
    mcsop mkvdisk -accessiogrp $j -cache readwrite -iogrp $j -mdiskgrp $j -name node${m}_${i} -node $m -nofmtdisk -size 1825361100800 -unit b
    usleep 500000
  done
  for i in {0..9}
  do
    echo "mcsop mkvdisk -accessiogrp $j -cache readwrite -iogrp $j -mdiskgrp $j -name node${n}_${i} -node $n -nofmtdisk -size 1825361100800 -unit b"
    mcsop mkvdisk -accessiogrp $j -cache readwrite -iogrp $j -mdiskgrp $j -name node${n}_${i} -node $n -nofmtdisk -size 1825361100800 -unit b
    usleep 500000
  done
done


#create hosts
mcsop mkhost -fcwwpn 100000109b5cab54:100000109b5cab55:100000109b5caba3:100000109b5caba4 -force -iogrp 0:1:2:3 -name node121 -type generic
mcsop mkhost -fcwwpn 100000109b610e28:100000109b610e29:100000109b1c8bde:100000109b1c8bdf -force -iogrp 0:1:2:3 -name node122 -type generic
mcsop mkhost -fcwwpn 100000109b527c7b:100000109b527c7c:100000109b418216:100000109b418217 -force -iogrp 0:1:2:3 -name node123 -type generic
mcsop mkhost -fcwwpn 100000109b211874:100000109b211875:100000109b50a03d:100000109b50a03e -force -iogrp 0:1:2:3 -name node124 -type generic
mcsop mkhost -fcwwpn 100000109b606b60:100000109b606b61:100000109b606b66:100000109b606b67 -force -iogrp 0:1:2:3 -name node125 -type generic
mcsop mkhost -fcwwpn 100000109b1d2740:100000109b1d2741:100000109b2119d6:100000109b2119d7 -force -iogrp 0:1:2:3 -name node126 -type generic
mcsop mkhost -fcwwpn 100000109b606b54:100000109b606b55:100000109b50a43b:100000109b50a43c -force -iogrp 0:1:2:3 -name node127 -type generic
mcsop mkhost -fcwwpn 100000109b5ca928:100000109b5ca929:100000109b5cac5c:100000109b5cac5d -force -iogrp 0:1:2:3 -name node128 -type generic
mcsop mkhost -fcwwpn 100000109b5621d0:100000109b5621d1:100000109b5688b6:100000109b5688b7 -force -iogrp 0:1:2:3 -name node129 -type generic
mcsop mkhost -fcwwpn 100000109b21547a:100000109b21547b:100000109b562629:100000109b56262a -force -iogrp 0:1:2:3 -name node130 -type generic
mcsop mkhost -fcwwpn 100000109b56261a:100000109b56261b:100000109b562605:100000109b562606 -force -iogrp 0:1:2:3 -name node131 -type generic
mcsop mkhost -fcwwpn 100000109b5ca9a2:100000109b5ca9a3:100000109b1cf68c:100000109b1cf68d -force -iogrp 0:1:2:3 -name node132 -type generic
mcsop mkhost -fcwwpn 100000109b6162b9:100000109b6162ba:100000109b5cab4c:100000109b5cab4d -force -iogrp 0:1:2:3 -name node133 -type generic
mcsop mkhost -fcwwpn 100000109b1cf660:100000109b1cf661:100000109b5caafd:100000109b5caafe -force -iogrp 0:1:2:3 -name node134 -type generic
mcsop mkhost -fcwwpn 100000109b1cf002:100000109b1cf003:100000109b610d62:100000109b610d63 -force -iogrp 0:1:2:3 -name node135 -type generic
mcsop mkhost -fcwwpn 100000109b327dd4:100000109b327dd5:10000090fadcb2f2:10000090fadcb2f3 -force -iogrp 0:1:2:3 -name node136 -type generic

#map lun to hosts
for i in {0..159}
do 
  for j in {0..15}
  do 
    mcsop mkvdiskhostmap -force -host $j $i 
	usleep 100000
  done
done


